#ifndef URL_SOURCE_DATA_H
#define URL_SOURCE_DATA_H

#include "request-data.h"
#include "mapping-data.h"

#include <obs-module.h>
#include <string>
#include <mutex>
#include <thread>
#include <condition_variable>

struct url_source_data {
	obs_source_t *source;
	struct url_source_request_data request_data;
	struct request_data_handler_response response;
	struct output_mapping_data output_mapping_data;
	uint32_t update_timer_ms = 1000;
	bool run_while_not_visible = false;
	bool output_is_image_url = false;
	struct obs_source_frame frame;
	bool send_to_stream = false;
	uint32_t render_width = 640;

	// Text source to output the text to
	std::mutex output_mapping_mutex;

	// Use std for thread and mutex
	std::mutex *curl_mutex = nullptr;
	std::thread curl_thread;
	std::condition_variable *curl_thread_cv = nullptr;
	bool curl_thread_run = false;
};

#endif
